<?php
namespace PME\Modules\Planejamento\Prato;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class TipoPratoController {

	protected $connection;

    public function __construct($connection) {
    	$this->connection = $connection;
	}
	
	public function retornaRegistroTipoPrato(DTO\Request $request, DTO\Response $response){
		$row = $request->getParameters();

		$query = "SELECT TP.CDTIPOPRAT, TP.NMTIPOPRAT, TP.IDSOBRLIMPTP, TP.IDMEDICAOKG, TP.CDGRTIPOPR, TP.DTULTATUTPRA, TP.NMREDUZIDO, TP.NRORG FROM TIPOPRAT  TP, GRTIPOPR  GP WHERE TP.CDGRTIPOPR = GP.CDGRTIPOPR (+) AND TP.CDGRTIPOPR = :CDGRTIPOPR ORDER BY NLSSORT(TP.CDTIPOPRAT, 'NLS_SORT=BINARY_AI')";
        $retornoQuery = [];
        foreach ($row['rows'] as $editedRow) {
            $params = array (
                'CDGRTIPOPR' => $editedRow['CDGRTIPOPR']
            );
     
			$stmt = $this->connection->prepare($query);
			$stmt->execute($params);
		    $result = $stmt->fetchAll();
		    $retornoQuery += $result;
        }
	    $response->addDataSet(new DataSet("result", [$retornoQuery]));
	   
	}
}