/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Pedidos                                                                    */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: 2804_PEDTRG_GRAVA_HISTORICO_PEDIDO                                   */
/*                                                                            */
/* Descrio:                                                                 */
/* Gravar o histrico das alteraes da tabela ITEMPEDIDO                     */
/*                                                                            */
/* Criao:                                                                   */
/* 05/09/2006 - Welbert Gonalves Moitinha                                    */
/******************************************************************************/
IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'GRAVA_HISTORICO_PEDIDO'and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
DROP TRIGGER GRAVA_HISTORICO_PEDIDO
GO
CREATE TRIGGER GRAVA_HISTORICO_PEDIDO
ON ITEMPEDIDO
FOR INSERT, UPDATE
AS
 DECLARE  @V_ID_COMANDO       VARCHAR(1);
 DECLARE  @V_CDFILIAL_OLD     VARCHAR(4);
 DECLARE  @V_NRPEDIDO_OLD     VARCHAR(10);
 DECLARE  @V_NRITEMPED_OLD    VARCHAR(10);
 DECLARE  @V_IDSITITEMPED_OLD VARCHAR(1);
 DECLARE  @V_CDOPERADOR_OLD   VARCHAR(12);
 DECLARE  @V_CDJUSTEXCHIS_OLD VARCHAR(4);
 DECLARE  @V_QTITEMPED_OLD DOUBLE PRECISION;


 DECLARE  @V_CDFILIAL_NEW     VARCHAR(4);
 DECLARE  @V_NRPEDIDO_NEW     VARCHAR(10);
 DECLARE  @V_NRITEMPED_NEW    VARCHAR(10);
 DECLARE  @V_IDSITITEMPED_NEW VARCHAR(1);
 DECLARE  @V_CDOPERADOR_NEW   VARCHAR(12);
 DECLARE  @V_CDJUSTEXCHIS_NEW VARCHAR(4);
 DECLARE  @V_QTITEMPED_NEW DOUBLE PRECISION; 
BEGIN

   DECLARE C_CURSOR CURSOR FOR
      SELECT
         'U' IDCOMANDO,
         INSERTED.CDFILIAL,
         INSERTED.NRPEDIDO,
         INSERTED.NRITEMPED,
         INSERTED.IDSITITEMPED,
         INSERTED.CDOPERADOR,
         INSERTED.CDJUSTEXCHIS,
         INSERTED.QTITEMPED,

         DELETED.CDFILIAL,
         DELETED.NRPEDIDO,
         DELETED.NRITEMPED,
         DELETED.IDSITITEMPED,
         DELETED.CDOPERADOR,
         DELETED.CDJUSTEXCHIS,
         DELETED.QTITEMPED
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDFILIAL  = DELETED.CDFILIAL AND
         INSERTED.NRPEDIDO  = DELETED.NRPEDIDO AND
         INSERTED.NRITEMPED = DELETED.NRITEMPED

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         INSERTED.CDFILIAL,
         INSERTED.NRPEDIDO,
         INSERTED.NRITEMPED,
         INSERTED.IDSITITEMPED,
         INSERTED.CDOPERADOR,
         INSERTED.CDJUSTEXCHIS,
         INSERTED.QTITEMPED, 
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDFILIAL_NEW,
                                 @V_NRPEDIDO_NEW,
                                 @V_NRITEMPED_NEW,
                                 @V_IDSITITEMPED_NEW,
                                 @V_CDOPERADOR_NEW,
                                 @V_CDJUSTEXCHIS_NEW,
                                 @V_QTITEMPED_NEW,
                                 @V_CDFILIAL_OLD,
                                 @V_NRPEDIDO_OLD,
                                 @V_NRITEMPED_OLD,
                                 @V_IDSITITEMPED_OLD,
                                 @V_CDOPERADOR_OLD,
                                 @V_CDJUSTEXCHIS_OLD,
                                 @V_QTITEMPED_OLD;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF (@V_ID_COMANDO = 'I') BEGIN
         INSERT INTO HISITEMPED
            (CDFILIAL, NRPEDIDO, NRITEMPED, DTHRHIST, IDSITATUHIST,
            IDSITANTHIST, CDOPEMANHIST,   CDJUSTEXCHIS, IDALTHISTITE, QTITEMPEDANT, QTITEMPEDATU)
         VALUES
            (@V_CDFILIAL_NEW, @V_NRPEDIDO_NEW, @V_NRITEMPED_NEW, GETDATE(), @V_IDSITITEMPED_NEW,
             @V_IDSITITEMPED_NEW, @V_CDOPERADOR_NEW, NULL , '1', NULL, @V_QTITEMPED_NEW);
      END
      ELSE  BEGIN
         IF (@V_ID_COMANDO = 'U') AND ( @V_IDSITITEMPED_OLD <> @V_IDSITITEMPED_NEW) BEGIN 
            INSERT INTO HISITEMPED
               (CDFILIAL, NRPEDIDO, NRITEMPED, DTHRHIST, IDSITATUHIST,
               IDSITANTHIST, CDOPEMANHIST,   CDJUSTEXCHIS, IDALTHISTITE, QTITEMPEDANT, QTITEMPEDATU)
            VALUES
               (@V_CDFILIAL_NEW, @V_NRPEDIDO_NEW, @V_NRITEMPED_NEW, GETDATE(), @V_IDSITITEMPED_NEW,
                @V_IDSITITEMPED_OLD, @V_CDOPERADOR_NEW, @V_CDJUSTEXCHIS_NEW , '1', NULL, NULL);
         END;
         
         IF (@V_ID_COMANDO = 'U') AND (@V_QTITEMPED_OLD <> @V_QTITEMPED_NEW) BEGIN
            INSERT INTO HISITEMPED
               (CDFILIAL, NRPEDIDO, NRITEMPED, DTHRHIST, IDSITATUHIST,
               IDSITANTHIST, CDOPEMANHIST,   CDJUSTEXCHIS, IDALTHISTITE, QTITEMPEDANT, QTITEMPEDATU)
            VALUES
               (@V_CDFILIAL_NEW, @V_NRPEDIDO_NEW, @V_NRITEMPED_NEW, GETDATE(), @V_IDSITITEMPED_NEW,
                @V_IDSITITEMPED_OLD, @V_CDOPERADOR_NEW, @V_CDJUSTEXCHIS_NEW , '1', @V_QTITEMPED_OLD, @V_QTITEMPED_NEW);
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO, @V_CDFILIAL_OLD, @V_NRPEDIDO_OLD,
                                    @V_NRITEMPED_OLD, @V_IDSITITEMPED_OLD, @V_CDOPERADOR_OLD,
                                    @V_CDJUSTEXCHIS_OLD, @V_QTITEMPED_OLD,
                                    @V_CDFILIAL_NEW, @V_NRPEDIDO_NEW, @V_NRITEMPED_NEW,
                                    @V_IDSITITEMPED_NEW, @V_CDOPERADOR_NEW, @V_CDJUSTEXCHIS_NEW,
                                    @V_QTITEMPED_NEW;
   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GRAVA_HISTORICO_PEDIDO','5.01.014';
GO

